{% set title = 'Sign Up' %} {% set admin = false %} {% extends 'base.html' %} {%
block content %}
<div class="sign-up">
  <label class="sign-up-product"> {{ product.name }} </label>
  <h2>
    Sign up for {{ plan.name }} &mdash; {{ plan.amount }} / {% if
    (plan.interval_count > 1) %} {{ plan.interval_count }} {{ plan.interval }}s
    {% else %} {{ plan.interval }} {% endif %}
  </h2>
  {% if success %}
  <div>
    <p>Your payment was successful. Congrats, you've successfully signed up!</p>
  </div>
  {% elif error %}
  <div>
    <p>Your payment was unsuccessful. Please try again.</p>
  </div>
  {% else %}
  <div class="sign-up-container">
    <form action="/processPayment" method="POST" id="payment-form">
      <input type="hidden" value="{{ product.name }}" name="productName" />
      <input type="hidden" value="{{ plan.id }}" name="planId" />
      <input type="hidden" value="{{ plan.amount }}" name="planAmount" />
      <input type="hidden" value="{{ plan.name }}" name="planName" />
      <input type="hidden" value="{{ plan.interval }}" name="planInterval" />
      <input
        type="hidden"
        value="{{ plan.interval_count }}"
        name="planIntervalCount"
      />

      <label> Email Address </label>
      <input placeholder="Your Email Address" name="customerEmail" />
      <div class="form-row">
        <label for="card-element"> Credit or debit card </label>
        <div id="card-element">
          <!-- A Stripe Elements instance will be mounted here -->
        </div>

        <!-- Any error messages will be mounted here -->
        <div id="card-errors" role="alert"></div>
      </div>

      <input class="btn" type="submit" value="Pay {{ plan.amount }}" />
    </form>
  </div>
  {% endif %}
</div>

<script>
  if (document.getElementById("card-element")) {
    var stripe = Stripe(
      "pk_test_51Jh6OnSFX2yixa3287WzJxrXHDJAqGSXoMGdi29h9k9ADNFkfiRPOUNNtQNVKRyFMbIwaLil2hxI3hcYldy3KJ8H00Bb8Y541x"
    );
    var elements = stripe.elements();

    var style = {
      base: {
        fontSize: "16px",
        "::placeholder": { color: "#aab7c4" },
        fontFamily: '"Open Sans", "Helvetica", sans-serif',
        fontSmoothing: "antialiased",
      },
      invalid: {
        color: "#fa755a",
        iconColor: "#fa755a",
      },
    };

    /* Create a Stripe Elements instance 
      and mount to the div with the id 'card-element' */

    var card = elements.create("card", { style: style });

    card.mount("#card-element");

    /* Handle validation errors */
    card.addEventListener("change", (event) => {
      var displayError = document.getElementById("card-errors");

      if (event.error) {
        displayError.textContent = event.error.message;
      } else {
        displayError.textContent = "";
      }
    });

    /* Create a token when the form is submitted */
    var form = document.getElementById("payment-form");

    form.addEventListener("submit", function (event) {
      event.preventDefault();

      stripe.createToken(card).then(function (result) {
        if (result.error) {
          var errorElement = document.getElementById("card-errors");
          errorElement.textContent = result.error.message;
        } else {
          stripeTokenHandler(result.token);
        }
      });
    });
  }

  function stripeTokenHandler(token) {
    var form = document.getElementById("payment-form");
    var hiddenInput = document.createElement("input");
    hiddenInput.setAttribute("type", "hidden");
    hiddenInput.setAttribute("name", "stripeToken");
    hiddenInput.setAttribute("value", token.id);
    form.appendChild(hiddenInput);
    form.submit();
  }
</script>

<style>
  /* This CSS is taken from the Stripe Elements Quickstart Guide (https://stripe.com/docs/stripe-js/elements/quickstart). 
   * It is used to style the container, not the actual inputs inside */
  .StripeElement {
    box-sizing: border-box;
    height: 40px;
    padding: 10px 12px;
    border: 1px solid transparent;
    border-radius: 4px;
    background-color: white;
    box-shadow: 0 1px 3px 0 #e6ebf1;
    -webkit-transition: box-shadow 150ms ease;
    transition: box-shadow 150ms ease;
  }

  .StripeElement--focus {
    box-shadow: 0 1px 3px 0 #cfd7df;
  }

  .StripeElement--invalid {
    border-color: #fa755a;
  }

  .StripeElement--webkit-autofill {
    background-color: #fefde5 !important;
  }
</style>

{% endblock %}
